//==============================================================
// 萔
float4x4 World;
float4x4 View;
float4x4 Proj;
float3 Light;
float4 Diffuse;
float4 Ambient;
float FocusZ;
float Scale;
float Red;
float Red2;
texture MeshTex;
texture Tex0;
texture Tex1;
texture Tex2;

//==============================================================
// eNX`Tv
sampler MeshSmp=sampler_state {
	Texture=<MeshTex>;
	MipFilter=LINEAR;
	MinFilter=LINEAR;
	MagFilter=LINEAR;
};
sampler Tex0Smp=sampler_state {
	Texture=<Tex0>;
	MipFilter=LINEAR;
	MinFilter=LINEAR;
	MagFilter=LINEAR;
};
sampler Tex1Smp=sampler_state {
	Texture=<Tex1>;
	MipFilter=LINEAR;
	MinFilter=LINEAR;
	MagFilter=LINEAR;
	AddressU = Clamp;
	AddressV = Clamp;
};
sampler Tex2Smp=sampler_state {
	Texture=<Tex2>;
	MipFilter=LINEAR;
	MinFilter=LINEAR;
	MagFilter=LINEAR;
	AddressU = Clamp;
	AddressV = Clamp;
};
sampler Tex0PointSmp=sampler_state {
	Texture=<Tex0>;
	MipFilter=POINT;
	MinFilter=POINT;
	MagFilter=POINT;
};

//==============================================================
// VF[_ieNX`ɃV[Ɛ[x`j

// _VF[_
void DOFSceneVS (
	float4 pos : POSITION,
	float3 normal : NORMAL,
	float2 mesh_uv : TEXCOORD0,
	out float4 Pos : POSITION,
	out float4 Col : COLOR0, 
	out float2 MeshUV : TEXCOORD0
) {
	// _W
	pos = mul(pos, World);
	pos = mul(pos, View);
	pos = mul(pos, Proj);
	
	Pos = pos;

	// eNX`W
	MeshUV=mesh_uv;

	// _F
	Col=Diffuse;

	// Eςɍ킹ĐFύX
	Col.r += 0.1 ;	Col.g += 0.25;	Col.b += 0.15;

	// ԃtOԂ
	Col.r += Red;	Col.g -= Red;	Col.b -= Red;
	Col.r += Red2;	Col.g -= Red2;	Col.b -= Red2;

	// [x𒸓_F̃At@ɏo
	Col.a=abs(pos.z-FocusZ)*Scale;
}

// sNZVF[_
float4 DOFScenePS(
	float4 Color : COLOR, 
	float2 MeshUV : TEXCOORD0
) : COLOR {
	return float4(tex2D(MeshSmp, MeshUV).rgb, 1)*Color;
}

//==============================================================
// VF[_ieNX`ĉʂɕ`j

// sNZVF[_
float4 DOFBlendPS(
	float4 TexUV : TEXCOORD0
) : COLOR {

	// [x̎擾
	float dz=tex2D(Tex0Smp, TexUV).a;
	float4 color;

	// [x0.0`0.5̂Ƃ̓eNX`0ƃeNX`1
	if (dz<0.5) {
		color=lerp(tex2D(Tex0Smp, TexUV), tex2D(Tex1Smp, TexUV), dz*2);
	}
	
	// [x0.5`1.0̂Ƃ̓eNX`1ƃeNX`2
	else {
		color=lerp(tex2D(Tex1Smp, TexUV), tex2D(Tex2Smp, TexUV), dz*2-1);
	}

	// Oɋ[Cgu
	if (dz<0.5) {
		float Lt = color * ((0.5 - dz) * 30);
		color *= Lt+1;
	}
	
	// FԂ
	return float4(color.rgb, 1);
}

// ẽVF[_
//==============================================================
// VF[_ie`j

// _VF[_
void DOFShadowVS (
	float4 pos : POSITION,
	float3 normal : NORMAL,
	float2 mesh_uv : TEXCOORD0,
	out float4 Pos : POSITION,
	out float4 Col : COLOR0, 
	out float2 MeshUV : TEXCOORD0
) {
	// _W
	pos = mul(pos, World);
	pos = mul(pos, View);
	pos = mul(pos, Proj);
	
	Pos = pos;

	// eNX`W
	MeshUV=mesh_uv;
	// fBt[YF
	Col=Diffuse;
}

// e`悷sNZVF[_
float4 DOFShadowPS(
	float4 TexUV : TEXCOORD0
) : COLOR {

	return float4( 0.0f, 0.01f, 0.01f, 0.32f);
}

// ʊE[x𖳌ɂꍇ̃sNZVF[_
float4 DOFNoBlendPS(
	float4 TexUV : TEXCOORD0
) : COLOR {
	return float4(tex2D(Tex0PointSmp, TexUV).rgb, 1);
}

// [x\ꍇ̃sNZVF[_
float4 DOFDepthPS(
	float4 TexUV : TEXCOORD0
) : COLOR {
	return float4(tex2D(Tex0PointSmp, TexUV).aaa, 1);
}

//==============================================================
// eNjbN

// V[̕`
technique Scene {
	pass P0 {
		AlphaBlendEnable=false;
		VertexShader=compile vs_1_1 DOFSceneVS();
		PixelShader=compile ps_2_0 DOFScenePS();
	}
}

// e̕`
technique Shadow {
	pass P0 {
		AlphaBlendEnable=true;
		VertexShader=compile vs_1_1 DOFShadowVS();
		PixelShader=compile ps_2_0 DOFShadowPS();
	}
}

// ʊE[xg
technique Blend {
	pass P0 {
		PixelShader=compile ps_2_0 DOFBlendPS();
	}
}

// ʊE[xg
technique NoBlend {
	pass P0 {
		PixelShader=compile ps_2_0 DOFNoBlendPS();
	}
}

// V[̐[x݂̂`
technique Depth {
	pass P0 {
		PixelShader=compile ps_2_0 DOFDepthPS();
	}
}
